/* WacomDevice.c generated by valac 0.56.8, the Vala compiler
 * generated from WacomDevice.vala, do not modify */

/*
 * Copyright (c) 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "wacom.h"
#include <libwacom/libwacom.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#define WACOM_BACKEND_WACOM_DEVICE_WACOM_TABLET_SCHEMA "org.gnome.desktop.peripherals.tablet"
#define WACOM_BACKEND_WACOM_DEVICE_WACOM_SETTINGS_BASE "/org/gnome/desktop/peripherals/tablets/%s:%s/"

enum  {
	WACOM_BACKEND_WACOM_DEVICE_0_PROPERTY,
	WACOM_BACKEND_WACOM_DEVICE_DEVICE_PROPERTY,
	WACOM_BACKEND_WACOM_DEVICE_IS_REVERSIBLE_PROPERTY,
	WACOM_BACKEND_WACOM_DEVICE_NUM_PROPERTIES
};
static GParamSpec* wacom_backend_wacom_device_properties[WACOM_BACKEND_WACOM_DEVICE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _libwacom_destroy0(var) ((var == NULL) ? NULL : (var = (libwacom_destroy (var), NULL)))
#define _libwacom_database_destroy0(var) ((var == NULL) ? NULL : (var = (libwacom_database_destroy (var), NULL)))
#define __vala_WacomError_free_function_address_of0(var) ((var == NULL) ? NULL : (var = (_vala_WacomError_free_function_address_of (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _WacomBackendWacomDevicePrivate {
	WacomBackendDevice* _device;
	WacomDevice* wacom_device;
	GSettings* wacom_settings;
};

static gint WacomBackendWacomDevice_private_offset;
static gpointer wacom_backend_wacom_device_parent_class = NULL;
static WacomDeviceDatabase* wacom_backend_wacom_device_wacom_db;
static WacomDeviceDatabase* wacom_backend_wacom_device_wacom_db = NULL;

static void _vala_WacomError_free_function_address_of (WacomError* self);
static void wacom_backend_wacom_device_finalize (GObject * obj);
static GType wacom_backend_wacom_device_get_type_once (void);
static void _vala_wacom_backend_wacom_device_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_wacom_backend_wacom_device_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);

GQuark
wacom_exception_quark (void)
{
	return g_quark_from_static_string ("wacom-exception-quark");
}

static GType
wacom_exception_get_type_once (void)
{
	static const GEnumValue values[] = {{WACOM_EXCEPTION_LIBWACOM_ERROR, "WACOM_EXCEPTION_LIBWACOM_ERROR", "libwacom-error"}, {0, NULL, NULL}};
	GType wacom_exception_type_id;
	wacom_exception_type_id = g_enum_register_static ("WacomException", values);
	return wacom_exception_type_id;
}

GType
wacom_exception_get_type (void)
{
	static volatile gsize wacom_exception_type_id__once = 0;
	if (g_once_init_enter (&wacom_exception_type_id__once)) {
		GType wacom_exception_type_id;
		wacom_exception_type_id = wacom_exception_get_type_once ();
		g_once_init_leave (&wacom_exception_type_id__once, wacom_exception_type_id);
	}
	return wacom_exception_type_id__once;
}

static inline gpointer
wacom_backend_wacom_device_get_instance_private (WacomBackendWacomDevice* self)
{
	return G_STRUCT_MEMBER_P (self, WacomBackendWacomDevice_private_offset);
}

static void
_vala_WacomError_free_function_address_of (WacomError* self)
{
	libwacom_error_free (&self);
}

WacomBackendWacomDevice*
wacom_backend_wacom_device_construct (GType object_type,
                                      WacomBackendDevice* device,
                                      GError** error)
{
	WacomBackendWacomDevice * self = NULL;
	WacomDeviceDatabase* _tmp0_;
	WacomError* _error_ = NULL;
	WacomError* _tmp2_;
	WacomDeviceDatabase* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	WacomError* _tmp6_;
	WacomDevice* _tmp7_;
	WacomDevice* _tmp8_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (device != NULL, NULL);
	self = (WacomBackendWacomDevice*) g_object_new (object_type, "device", device, NULL);
	_tmp0_ = wacom_backend_wacom_device_wacom_db;
	if (_tmp0_ == NULL) {
		WacomDeviceDatabase* _tmp1_;
		_tmp1_ = libwacom_database_new ();
		_libwacom_database_destroy0 (wacom_backend_wacom_device_wacom_db);
		wacom_backend_wacom_device_wacom_db = _tmp1_;
	}
	_tmp2_ = libwacom_error_new ();
	_error_ = _tmp2_;
	_tmp3_ = wacom_backend_wacom_device_wacom_db;
	_tmp4_ = wacom_backend_device_get_device_file (device);
	_tmp5_ = _tmp4_;
	_tmp6_ = _error_;
	_tmp7_ = libwacom_new_from_path (_tmp3_, _tmp5_, WFALLBACK_NONE, _tmp6_);
	_libwacom_destroy0 (self->priv->wacom_device);
	self->priv->wacom_device = _tmp7_;
	_tmp8_ = self->priv->wacom_device;
	if (_tmp8_ == NULL) {
		const gchar* _tmp9_ = NULL;
		WacomError* _tmp10_;
		const gchar* _tmp11_;
		GError* _tmp12_;
		_tmp10_ = _error_;
		_tmp11_ = libwacom_error_get_message (_tmp10_);
		_tmp9_ = _tmp11_;
		if (_tmp9_ == NULL) {
			_tmp9_ = "";
		}
		_tmp12_ = g_error_new_literal (WACOM_EXCEPTION, WACOM_EXCEPTION_LIBWACOM_ERROR, _tmp9_);
		_inner_error0_ = _tmp12_;
		if (_inner_error0_->domain == WACOM_EXCEPTION) {
			g_propagate_error (error, _inner_error0_);
			__vala_WacomError_free_function_address_of0 (_error_);
			_g_object_unref0 (self);
			return NULL;
		} else {
			__vala_WacomError_free_function_address_of0 (_error_);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	__vala_WacomError_free_function_address_of0 (_error_);
	return self;
}

WacomBackendWacomDevice*
wacom_backend_wacom_device_new (WacomBackendDevice* device,
                                GError** error)
{
	return wacom_backend_wacom_device_construct (WACOM_BACKEND_TYPE_WACOM_DEVICE, device, error);
}

gint*
wacom_backend_wacom_device_get_supported_tools (WacomBackendWacomDevice* self,
                                                gint* result_length1)
{
	WacomDevice* _tmp0_;
	WacomDevice* _tmp3_;
	gint _tmp4_ = 0;
	gint* _tmp5_;
	gint* _tmp6_;
	gint _tmp6__length1;
	gint* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->wacom_device;
	if (_tmp0_ == NULL) {
		gint* _tmp1_;
		gint* _tmp2_;
		gint _tmp2__length1;
		_tmp1_ = g_new0 (gint, 0);
		_tmp2_ = _tmp1_;
		_tmp2__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp2__length1;
		}
		result = _tmp2_;
		return result;
	}
	_tmp3_ = self->priv->wacom_device;
	_tmp5_ = libwacom_get_supported_styli (_tmp3_, &_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp6__length1 = _tmp4_;
	if (result_length1) {
		*result_length1 = _tmp6__length1;
	}
	result = _tmp6_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

GSettings*
wacom_backend_wacom_device_get_settings (WacomBackendWacomDevice* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	GSettings* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->wacom_settings;
	if (_tmp0_ == NULL) {
		gchar* path = NULL;
		WacomBackendDevice* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		WacomBackendDevice* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		GSettings* _tmp9_;
		_tmp1_ = self->priv->_device;
		_tmp2_ = wacom_backend_device_get_vendor_id (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = self->priv->_device;
		_tmp5_ = wacom_backend_device_get_product_id (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_strdup_printf (WACOM_BACKEND_WACOM_DEVICE_WACOM_SETTINGS_BASE, _tmp3_, _tmp6_);
		path = _tmp7_;
		_tmp8_ = path;
		_tmp9_ = g_settings_new_with_path (WACOM_BACKEND_WACOM_DEVICE_WACOM_TABLET_SCHEMA, _tmp8_);
		_g_object_unref0 (self->priv->wacom_settings);
		self->priv->wacom_settings = _tmp9_;
		_g_free0 (path);
	}
	_tmp10_ = self->priv->wacom_settings;
	_tmp11_ = _g_object_ref0 (_tmp10_);
	result = _tmp11_;
	return result;
}

WacomBackendDevice*
wacom_backend_wacom_device_get_device (WacomBackendWacomDevice* self)
{
	WacomBackendDevice* result;
	WacomBackendDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_device;
	result = _tmp0_;
	return result;
}

static void
wacom_backend_wacom_device_set_device (WacomBackendWacomDevice* self,
                                       WacomBackendDevice* value)
{
	WacomBackendDevice* old_value;
	g_return_if_fail (self != NULL);
	old_value = wacom_backend_wacom_device_get_device (self);
	if (old_value != value) {
		WacomBackendDevice* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_device);
		self->priv->_device = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, wacom_backend_wacom_device_properties[WACOM_BACKEND_WACOM_DEVICE_DEVICE_PROPERTY]);
	}
}

static gboolean
_vala_libwacom_is_reversible (WacomDevice* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = libwacom_is_reversible (self) != 0;
	return result;
}

gboolean
wacom_backend_wacom_device_get_is_reversible (WacomBackendWacomDevice* self)
{
	gboolean result;
	WacomDevice* _tmp0_;
	WacomDevice* _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->wacom_device;
	if (_tmp0_ == NULL) {
		result = FALSE;
		return result;
	}
	_tmp1_ = self->priv->wacom_device;
	result = _vala_libwacom_is_reversible (_tmp1_);
	return result;
}

static void
wacom_backend_wacom_device_class_init (WacomBackendWacomDeviceClass * klass,
                                       gpointer klass_data)
{
	wacom_backend_wacom_device_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WacomBackendWacomDevice_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_wacom_backend_wacom_device_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_wacom_backend_wacom_device_set_property;
	G_OBJECT_CLASS (klass)->finalize = wacom_backend_wacom_device_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WACOM_BACKEND_WACOM_DEVICE_DEVICE_PROPERTY, wacom_backend_wacom_device_properties[WACOM_BACKEND_WACOM_DEVICE_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", WACOM_BACKEND_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WACOM_BACKEND_WACOM_DEVICE_IS_REVERSIBLE_PROPERTY, wacom_backend_wacom_device_properties[WACOM_BACKEND_WACOM_DEVICE_IS_REVERSIBLE_PROPERTY] = g_param_spec_boolean ("is-reversible", "is-reversible", "is-reversible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
wacom_backend_wacom_device_instance_init (WacomBackendWacomDevice * self,
                                          gpointer klass)
{
	self->priv = wacom_backend_wacom_device_get_instance_private (self);
	self->priv->wacom_device = NULL;
	self->priv->wacom_settings = NULL;
}

static void
wacom_backend_wacom_device_finalize (GObject * obj)
{
	WacomBackendWacomDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WACOM_BACKEND_TYPE_WACOM_DEVICE, WacomBackendWacomDevice);
	_g_object_unref0 (self->priv->_device);
	_libwacom_destroy0 (self->priv->wacom_device);
	_g_object_unref0 (self->priv->wacom_settings);
	G_OBJECT_CLASS (wacom_backend_wacom_device_parent_class)->finalize (obj);
}

static GType
wacom_backend_wacom_device_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WacomBackendWacomDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wacom_backend_wacom_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WacomBackendWacomDevice), 0, (GInstanceInitFunc) wacom_backend_wacom_device_instance_init, NULL };
	GType wacom_backend_wacom_device_type_id;
	wacom_backend_wacom_device_type_id = g_type_register_static (G_TYPE_OBJECT, "WacomBackendWacomDevice", &g_define_type_info, 0);
	WacomBackendWacomDevice_private_offset = g_type_add_instance_private (wacom_backend_wacom_device_type_id, sizeof (WacomBackendWacomDevicePrivate));
	return wacom_backend_wacom_device_type_id;
}

GType
wacom_backend_wacom_device_get_type (void)
{
	static volatile gsize wacom_backend_wacom_device_type_id__once = 0;
	if (g_once_init_enter (&wacom_backend_wacom_device_type_id__once)) {
		GType wacom_backend_wacom_device_type_id;
		wacom_backend_wacom_device_type_id = wacom_backend_wacom_device_get_type_once ();
		g_once_init_leave (&wacom_backend_wacom_device_type_id__once, wacom_backend_wacom_device_type_id);
	}
	return wacom_backend_wacom_device_type_id__once;
}

static void
_vala_wacom_backend_wacom_device_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	WacomBackendWacomDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WACOM_BACKEND_TYPE_WACOM_DEVICE, WacomBackendWacomDevice);
	switch (property_id) {
		case WACOM_BACKEND_WACOM_DEVICE_DEVICE_PROPERTY:
		g_value_set_object (value, wacom_backend_wacom_device_get_device (self));
		break;
		case WACOM_BACKEND_WACOM_DEVICE_IS_REVERSIBLE_PROPERTY:
		g_value_set_boolean (value, wacom_backend_wacom_device_get_is_reversible (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_wacom_backend_wacom_device_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	WacomBackendWacomDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WACOM_BACKEND_TYPE_WACOM_DEVICE, WacomBackendWacomDevice);
	switch (property_id) {
		case WACOM_BACKEND_WACOM_DEVICE_DEVICE_PROPERTY:
		wacom_backend_wacom_device_set_device (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

