/* Plug.c generated by valac 0.56.8, the Vala compiler
 * generated from Plug.vala, do not modify */

/*
 * Copyright (c) 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "wacom.h"
#include <gtk/gtk.h>
#include <gee.h>
#include <glib-object.h>
#include <switchboard.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <gdk/gdk.h>
#include <gmodule.h>

enum  {
	WACOM_PLUG_0_PROPERTY,
	WACOM_PLUG_NUM_PROPERTIES
};
static GParamSpec* wacom_plug_properties[WACOM_PLUG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _WacomPlugSearchData WacomPlugSearchData;

struct _WacomPlugPrivate {
	GtkStack* main_stack;
	GtkScrolledWindow* scrolled;
	GtkStack* empty_stack;
	WacomStylusView* stylus_view;
	WacomTabletView* tablet_view;
	WacomBackendDeviceManager* device_manager;
	GeeHashMap* devices;
	WacomBackendWacomTool* last_stylus;
	WacomBackendWacomToolMap* tool_map;
};

struct _WacomPlugSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	WacomPlug* self;
	gchar* search;
	GeeTreeMap* result;
	GeeTreeMap* search_results;
	GCompareFunc _tmp0_;
	GEqualFunc _tmp1_;
	GeeTreeMap* _tmp2_;
};

static gint WacomPlug_private_offset;
static gpointer wacom_plug_parent_class = NULL;

static GtkWidget* wacom_plug_real_get_widget (SwitchboardPlug* base);
static gboolean wacom_plug_update_current_tool (WacomPlug* self,
                                         GdkEvent* event);
static gboolean _wacom_plug_update_current_tool_gtk_widget_event (GtkWidget* _sender,
                                                           GdkEvent* event,
                                                           gpointer self);
static void wacom_plug_on_device_added (WacomPlug* self,
                                 WacomBackendDevice* device);
static void _wacom_plug_on_device_added_wacom_backend_device_manager_device_added (WacomBackendDeviceManager* _sender,
                                                                            WacomBackendDevice* device,
                                                                            gpointer self);
static void wacom_plug_on_device_removed (WacomPlug* self,
                                   WacomBackendDevice* device);
static void _wacom_plug_on_device_removed_wacom_backend_device_manager_device_removed (WacomBackendDeviceManager* _sender,
                                                                                WacomBackendDevice* device,
                                                                                gpointer self);
static void wacom_plug_add_known_device (WacomPlug* self,
                                  WacomBackendDevice* d);
static void wacom_plug_update_current_page (WacomPlug* self);
static void wacom_plug_real_shown (SwitchboardPlug* base);
static void wacom_plug_real_hidden (SwitchboardPlug* base);
static void wacom_plug_real_search_callback (SwitchboardPlug* base,
                                      const gchar* location);
static void wacom_plug_real_search_data_free (gpointer _data);
static void wacom_plug_real_search (SwitchboardPlug* base,
                             const gchar* search,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_);
static gboolean wacom_plug_real_search_co (WacomPlugSearchData* _data_);
static void wacom_plug_finalize (GObject * obj);
static GType wacom_plug_get_type_once (void);

static inline gpointer
wacom_plug_get_instance_private (WacomPlug* self)
{
	return G_STRUCT_MEMBER_P (self, WacomPlug_private_offset);
}

WacomPlug*
wacom_plug_construct (GType object_type)
{
	WacomPlug * self = NULL;
	GeeTreeMap* settings = NULL;
	GeeTreeMap* _tmp0_;
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
	settings = _tmp0_;
	gee_abstract_map_set ((GeeAbstractMap*) settings, "input/pointing/stylus", "general");
	gee_abstract_map_set ((GeeAbstractMap*) settings, "input/wacom", "general");
	self = (WacomPlug*) g_object_new (object_type, "category", SWITCHBOARD_PLUG_CATEGORY_HARDWARE, "code-name", "pantheon-wacom", "display-name", _ ("Wacom"), "description", _ ("Configure Wacom tablet"), "icon", "input-tablet", "supported-settings", settings, NULL);
	_g_object_unref0 (settings);
	return self;
}

WacomPlug*
wacom_plug_new (void)
{
	return wacom_plug_construct (WACOM_TYPE_PLUG);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
_wacom_plug_update_current_tool_gtk_widget_event (GtkWidget* _sender,
                                                  GdkEvent* event,
                                                  gpointer self)
{
	gboolean result;
	result = wacom_plug_update_current_tool ((WacomPlug*) self, event);
	return result;
}

static void
_wacom_plug_on_device_added_wacom_backend_device_manager_device_added (WacomBackendDeviceManager* _sender,
                                                                       WacomBackendDevice* device,
                                                                       gpointer self)
{
	wacom_plug_on_device_added ((WacomPlug*) self, device);
}

static void
_wacom_plug_on_device_removed_wacom_backend_device_manager_device_removed (WacomBackendDeviceManager* _sender,
                                                                           WacomBackendDevice* device,
                                                                           gpointer self)
{
	wacom_plug_on_device_removed ((WacomPlug*) self, device);
}

static GtkWidget*
wacom_plug_real_get_widget (SwitchboardPlug* base)
{
	WacomPlug * self;
	GtkStack* _tmp0_;
	GtkStack* _tmp53_;
	GtkWidget* _tmp54_;
	GtkWidget* result;
	self = (WacomPlug*) base;
	_tmp0_ = self->priv->empty_stack;
	if (_tmp0_ == NULL) {
		GeeHashMap* _tmp1_;
		WacomBackendWacomToolMap* _tmp4_;
		WacomBackendWacomToolMap* _tmp5_;
		WacomStylusView* _tmp6_;
		WacomTabletView* _tmp7_;
		GtkStack* _tmp8_;
		GtkStack* _tmp9_;
		GtkStack* _tmp10_;
		WacomStylusView* _tmp11_;
		GtkStack* _tmp12_;
		WacomTabletView* _tmp13_;
		GtkStackSwitcher* switcher = NULL;
		GtkStackSwitcher* _tmp14_;
		GtkStackSwitcher* _tmp15_;
		GtkStackSwitcher* _tmp16_;
		GtkStackSwitcher* _tmp17_;
		GtkStackSwitcher* _tmp18_;
		GtkStack* _tmp19_;
		GtkGrid* main_grid = NULL;
		GtkGrid* _tmp20_;
		GtkGrid* _tmp21_;
		GtkGrid* _tmp22_;
		GtkStackSwitcher* _tmp23_;
		GtkGrid* _tmp24_;
		GtkStack* _tmp25_;
		GtkScrolledWindow* _tmp26_;
		GtkScrolledWindow* _tmp27_;
		GtkGrid* _tmp28_;
		GtkScrolledWindow* _tmp29_;
		GraniteWidgetsAlertView* alert_view = NULL;
		GraniteWidgetsAlertView* _tmp30_;
		GtkStack* _tmp31_;
		GtkStack* _tmp32_;
		GtkScrolledWindow* _tmp33_;
		GtkStack* _tmp34_;
		GraniteWidgetsAlertView* _tmp35_;
		GtkStack* _tmp36_;
		GtkStack* _tmp37_;
		GtkStack* _tmp38_;
		WacomBackendDeviceManager* _tmp39_;
		WacomBackendDeviceManager* _tmp40_;
		WacomBackendDeviceManager* _tmp41_;
		WacomBackendDeviceManager* _tmp42_;
		_tmp1_ = self->priv->devices;
		if (_tmp1_ == NULL) {
			GeeHashMap* _tmp2_;
			_tmp2_ = gee_hash_map_new (WACOM_BACKEND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, WACOM_BACKEND_TYPE_WACOM_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
			_g_object_unref0 (self->priv->devices);
			self->priv->devices = _tmp2_;
		} else {
			GeeHashMap* _tmp3_;
			_tmp3_ = self->priv->devices;
			gee_abstract_map_clear ((GeeAbstractMap*) _tmp3_);
		}
		_tmp4_ = wacom_backend_wacom_tool_map_get_default ();
		_tmp5_ = _g_object_ref0 (_tmp4_);
		_g_object_unref0 (self->priv->tool_map);
		self->priv->tool_map = _tmp5_;
		_tmp6_ = wacom_stylus_view_new ();
		g_object_ref_sink (_tmp6_);
		_g_object_unref0 (self->priv->stylus_view);
		self->priv->stylus_view = _tmp6_;
		_tmp7_ = wacom_tablet_view_new ();
		g_object_ref_sink (_tmp7_);
		_g_object_unref0 (self->priv->tablet_view);
		self->priv->tablet_view = _tmp7_;
		_tmp8_ = (GtkStack*) gtk_stack_new ();
		g_object_ref_sink (_tmp8_);
		_g_object_unref0 (self->priv->main_stack);
		self->priv->main_stack = _tmp8_;
		_tmp9_ = self->priv->main_stack;
		g_object_set ((GtkWidget*) _tmp9_, "margin", 12, NULL);
		_tmp10_ = self->priv->main_stack;
		_tmp11_ = self->priv->stylus_view;
		gtk_stack_add_titled (_tmp10_, (GtkWidget*) _tmp11_, "stylus", _ ("Stylus"));
		_tmp12_ = self->priv->main_stack;
		_tmp13_ = self->priv->tablet_view;
		gtk_stack_add_titled (_tmp12_, (GtkWidget*) _tmp13_, "tablet", _ ("Tablet"));
		_tmp14_ = (GtkStackSwitcher*) gtk_stack_switcher_new ();
		g_object_ref_sink (_tmp14_);
		switcher = _tmp14_;
		_tmp15_ = switcher;
		gtk_widget_set_halign ((GtkWidget*) _tmp15_, GTK_ALIGN_CENTER);
		_tmp16_ = switcher;
		gtk_box_set_homogeneous ((GtkBox*) _tmp16_, TRUE);
		_tmp17_ = switcher;
		g_object_set ((GtkWidget*) _tmp17_, "margin", 12, NULL);
		_tmp18_ = switcher;
		_tmp19_ = self->priv->main_stack;
		gtk_stack_switcher_set_stack (_tmp18_, _tmp19_);
		_tmp20_ = (GtkGrid*) gtk_grid_new ();
		g_object_ref_sink (_tmp20_);
		main_grid = _tmp20_;
		_tmp21_ = main_grid;
		gtk_widget_set_halign ((GtkWidget*) _tmp21_, GTK_ALIGN_CENTER);
		_tmp22_ = main_grid;
		_tmp23_ = switcher;
		gtk_grid_attach (_tmp22_, (GtkWidget*) _tmp23_, 0, 0, 1, 1);
		_tmp24_ = main_grid;
		_tmp25_ = self->priv->main_stack;
		gtk_grid_attach (_tmp24_, (GtkWidget*) _tmp25_, 0, 1, 1, 1);
		_tmp26_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
		g_object_ref_sink (_tmp26_);
		_g_object_unref0 (self->priv->scrolled);
		self->priv->scrolled = _tmp26_;
		_tmp27_ = self->priv->scrolled;
		_tmp28_ = main_grid;
		gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
		_tmp29_ = self->priv->scrolled;
		gtk_widget_show_all ((GtkWidget*) _tmp29_);
		_tmp30_ = granite_widgets_alert_view_new (_ ("No Tablets Available"), _ ("Please ensure your tablet is connected and switched on"), "input-tablet");
		g_object_ref_sink (_tmp30_);
		alert_view = _tmp30_;
		_tmp31_ = (GtkStack*) gtk_stack_new ();
		g_object_ref_sink (_tmp31_);
		_g_object_unref0 (self->priv->empty_stack);
		self->priv->empty_stack = _tmp31_;
		_tmp32_ = self->priv->empty_stack;
		_tmp33_ = self->priv->scrolled;
		gtk_stack_add_named (_tmp32_, (GtkWidget*) _tmp33_, "main_view");
		_tmp34_ = self->priv->empty_stack;
		_tmp35_ = alert_view;
		gtk_stack_add_named (_tmp34_, (GtkWidget*) _tmp35_, "no_tablets");
		_tmp36_ = self->priv->empty_stack;
		gtk_widget_show_all ((GtkWidget*) _tmp36_);
		_tmp37_ = self->priv->empty_stack;
		gtk_stack_set_visible_child_name (_tmp37_, "no_tablets");
		_tmp38_ = self->priv->empty_stack;
		g_signal_connect_object ((GtkWidget*) _tmp38_, "event", (GCallback) _wacom_plug_update_current_tool_gtk_widget_event, self, 0);
		_tmp39_ = wacom_backend_device_manager_get_default ();
		_tmp40_ = _g_object_ref0 (_tmp39_);
		_g_object_unref0 (self->priv->device_manager);
		self->priv->device_manager = _tmp40_;
		_tmp41_ = self->priv->device_manager;
		g_signal_connect_object (_tmp41_, "device-added", (GCallback) _wacom_plug_on_device_added_wacom_backend_device_manager_device_added, self, 0);
		_tmp42_ = self->priv->device_manager;
		g_signal_connect_object (_tmp42_, "device-removed", (GCallback) _wacom_plug_on_device_removed_wacom_backend_device_manager_device_removed, self, 0);
		{
			GeeArrayList* _device_list = NULL;
			WacomBackendDeviceManager* _tmp43_;
			GeeArrayList* _tmp44_;
			gint _device_size = 0;
			GeeArrayList* _tmp45_;
			gint _tmp46_;
			gint _tmp47_;
			gint _device_index = 0;
			_tmp43_ = self->priv->device_manager;
			_tmp44_ = wacom_backend_device_manager_list_devices (_tmp43_, WACOM_BACKEND_DEVICE_DEVICE_TYPE_TABLET);
			_device_list = _tmp44_;
			_tmp45_ = _device_list;
			_tmp46_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp45_);
			_tmp47_ = _tmp46_;
			_device_size = _tmp47_;
			_device_index = -1;
			while (TRUE) {
				gint _tmp48_;
				gint _tmp49_;
				WacomBackendDevice* device = NULL;
				GeeArrayList* _tmp50_;
				gpointer _tmp51_;
				WacomBackendDevice* _tmp52_;
				_device_index = _device_index + 1;
				_tmp48_ = _device_index;
				_tmp49_ = _device_size;
				if (!(_tmp48_ < _tmp49_)) {
					break;
				}
				_tmp50_ = _device_list;
				_tmp51_ = gee_abstract_list_get ((GeeAbstractList*) _tmp50_, _device_index);
				device = (WacomBackendDevice*) _tmp51_;
				_tmp52_ = device;
				wacom_plug_add_known_device (self, _tmp52_);
				_g_object_unref0 (device);
			}
			_g_object_unref0 (_device_list);
		}
		wacom_plug_update_current_page (self);
		_g_object_unref0 (alert_view);
		_g_object_unref0 (main_grid);
		_g_object_unref0 (switcher);
	}
	_tmp53_ = self->priv->empty_stack;
	_tmp54_ = _g_object_ref0 ((GtkWidget*) _tmp53_);
	result = _tmp54_;
	return result;
}

static gboolean
wacom_plug_update_current_tool (WacomPlug* self,
                                GdkEvent* event)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	if (gdk_event_get_event_type (event) == GDK_MOTION_NOTIFY) {
		GdkDeviceTool* tool = NULL;
		GdkDeviceTool* _tmp0_;
		GdkDeviceTool* _tmp1_;
		GdkDeviceTool* _tmp2_;
		WacomBackendDevice* device = NULL;
		WacomBackendDeviceManager* _tmp3_;
		GdkDevice* _tmp4_;
		WacomBackendDevice* _tmp5_;
		WacomBackendDevice* _tmp6_;
		WacomBackendWacomDevice* wacom_device = NULL;
		GeeHashMap* _tmp7_;
		WacomBackendDevice* _tmp8_;
		gpointer _tmp9_;
		WacomBackendWacomDevice* _tmp10_;
		guint64 serial = 0ULL;
		GdkDeviceTool* _tmp11_;
		WacomBackendWacomTool* stylus = NULL;
		WacomBackendWacomToolMap* _tmp12_;
		WacomBackendWacomDevice* _tmp13_;
		WacomBackendWacomTool* _tmp14_;
		WacomBackendWacomTool* _tmp15_;
		WacomBackendWacomToolMap* _tmp22_;
		WacomBackendWacomDevice* _tmp23_;
		WacomBackendWacomTool* _tmp24_;
		WacomBackendWacomTool* _tmp25_;
		WacomBackendWacomTool* _tmp26_;
		WacomBackendWacomTool* _tmp29_;
		WacomBackendWacomTool* _tmp30_;
		_tmp0_ = gdk_event_get_device_tool (event);
		_tmp1_ = _g_object_ref0 (_tmp0_);
		tool = _tmp1_;
		_tmp2_ = tool;
		if (_tmp2_ == NULL) {
			result = GDK_EVENT_PROPAGATE;
			_g_object_unref0 (tool);
			return result;
		}
		_tmp3_ = self->priv->device_manager;
		_tmp4_ = gdk_event_get_source_device (event);
		_tmp5_ = wacom_backend_device_manager_lookup_gdk_device (_tmp3_, _tmp4_);
		device = _tmp5_;
		_tmp6_ = device;
		if (_tmp6_ == NULL) {
			result = GDK_EVENT_PROPAGATE;
			_g_object_unref0 (device);
			_g_object_unref0 (tool);
			return result;
		}
		_tmp7_ = self->priv->devices;
		_tmp8_ = device;
		_tmp9_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, _tmp8_);
		wacom_device = (WacomBackendWacomDevice*) _tmp9_;
		_tmp10_ = wacom_device;
		if (_tmp10_ == NULL) {
			result = GDK_EVENT_PROPAGATE;
			_g_object_unref0 (wacom_device);
			_g_object_unref0 (device);
			_g_object_unref0 (tool);
			return result;
		}
		_tmp11_ = tool;
		serial = gdk_device_tool_get_serial (_tmp11_);
		_tmp12_ = self->priv->tool_map;
		_tmp13_ = wacom_device;
		_tmp14_ = wacom_backend_wacom_tool_map_lookup_tool (_tmp12_, _tmp13_, serial);
		stylus = _tmp14_;
		_tmp15_ = stylus;
		if (_tmp15_ == NULL) {
			guint64 id = 0ULL;
			GdkDeviceTool* _tmp16_;
			_tmp16_ = tool;
			id = gdk_device_tool_get_hardware_id (_tmp16_);
			{
				WacomBackendWacomTool* _tmp17_ = NULL;
				WacomBackendWacomDevice* _tmp18_;
				WacomBackendWacomTool* _tmp19_;
				WacomBackendWacomTool* _tmp20_;
				_tmp18_ = wacom_device;
				_tmp19_ = wacom_backend_wacom_tool_new (serial, id, _tmp18_, &_inner_error0_);
				_tmp17_ = _tmp19_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch0_g_error;
				}
				_tmp20_ = _tmp17_;
				_tmp17_ = NULL;
				_g_object_unref0 (stylus);
				stylus = _tmp20_;
				_g_object_unref0 (_tmp17_);
			}
			goto __finally0;
			__catch0_g_error:
			{
				g_clear_error (&_inner_error0_);
				result = GDK_EVENT_PROPAGATE;
				_g_object_unref0 (stylus);
				_g_object_unref0 (wacom_device);
				_g_object_unref0 (device);
				_g_object_unref0 (tool);
				return result;
			}
			__finally0:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				gboolean _tmp21_ = FALSE;
				_g_object_unref0 (stylus);
				_g_object_unref0 (wacom_device);
				_g_object_unref0 (device);
				_g_object_unref0 (tool);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp21_;
			}
		}
		_tmp22_ = self->priv->tool_map;
		_tmp23_ = wacom_device;
		_tmp24_ = stylus;
		wacom_backend_wacom_tool_map_add_relation (_tmp22_, _tmp23_, _tmp24_);
		_tmp25_ = stylus;
		_tmp26_ = self->priv->last_stylus;
		if (_tmp25_ != _tmp26_) {
			WacomStylusView* _tmp27_;
			WacomBackendWacomTool* _tmp28_;
			_tmp27_ = self->priv->stylus_view;
			_tmp28_ = stylus;
			wacom_stylus_view_set_device (_tmp27_, _tmp28_);
		}
		_tmp29_ = stylus;
		_tmp30_ = _g_object_ref0 (_tmp29_);
		_g_object_unref0 (self->priv->last_stylus);
		self->priv->last_stylus = _tmp30_;
		_g_object_unref0 (stylus);
		_g_object_unref0 (wacom_device);
		_g_object_unref0 (device);
		_g_object_unref0 (tool);
	}
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static void
wacom_plug_add_known_device (WacomPlug* self,
                             WacomBackendDevice* d)
{
	WacomBackendDeviceDeviceType _tmp0_;
	WacomBackendDeviceDeviceType _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	WacomBackendDeviceDeviceType _tmp4_;
	WacomBackendDeviceDeviceType _tmp5_;
	GeeArrayList* tools = NULL;
	WacomBackendWacomToolMap* _tmp15_;
	GeeHashMap* _tmp16_;
	gpointer _tmp17_;
	WacomBackendWacomDevice* _tmp18_;
	GeeArrayList* _tmp19_;
	GeeArrayList* _tmp20_;
	GeeArrayList* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (d != NULL);
	_tmp0_ = wacom_backend_device_get_dev_type (d);
	_tmp1_ = _tmp0_;
	if (!((_tmp1_ & WACOM_BACKEND_DEVICE_DEVICE_TYPE_TABLET) == WACOM_BACKEND_DEVICE_DEVICE_TYPE_TABLET)) {
		return;
	}
	_tmp4_ = wacom_backend_device_get_dev_type (d);
	_tmp5_ = _tmp4_;
	if ((_tmp5_ & WACOM_BACKEND_DEVICE_DEVICE_TYPE_TOUCHSCREEN) == WACOM_BACKEND_DEVICE_DEVICE_TYPE_TOUCHSCREEN) {
		_tmp3_ = TRUE;
	} else {
		WacomBackendDeviceDeviceType _tmp6_;
		WacomBackendDeviceDeviceType _tmp7_;
		_tmp6_ = wacom_backend_device_get_dev_type (d);
		_tmp7_ = _tmp6_;
		_tmp3_ = (_tmp7_ & WACOM_BACKEND_DEVICE_DEVICE_TYPE_TOUCHPAD) == WACOM_BACKEND_DEVICE_DEVICE_TYPE_TOUCHPAD;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		WacomBackendDeviceDeviceType _tmp8_;
		WacomBackendDeviceDeviceType _tmp9_;
		_tmp8_ = wacom_backend_device_get_dev_type (d);
		_tmp9_ = _tmp8_;
		_tmp2_ = (_tmp9_ & WACOM_BACKEND_DEVICE_DEVICE_TYPE_PAD) == WACOM_BACKEND_DEVICE_DEVICE_TYPE_PAD;
	}
	if (_tmp2_) {
		return;
	}
	{
		WacomBackendWacomDevice* _tmp10_ = NULL;
		WacomBackendWacomDevice* _tmp11_;
		GeeHashMap* _tmp12_;
		_tmp11_ = wacom_backend_wacom_device_new (d, &_inner_error0_);
		_tmp10_ = _tmp11_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == WACOM_EXCEPTION) {
				goto __catch0_wacom_exception;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp12_ = self->priv->devices;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp12_, d, _tmp10_);
		_g_object_unref0 (_tmp10_);
	}
	goto __finally0;
	__catch0_wacom_exception:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp13_ = e;
		_tmp14_ = _tmp13_->message;
		g_warning ("Plug.vala:173: Error initializing Wacom device: %s", _tmp14_);
		_g_error_free0 (e);
		return;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp15_ = self->priv->tool_map;
	_tmp16_ = self->priv->devices;
	_tmp17_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp16_, d);
	_tmp18_ = (WacomBackendWacomDevice*) _tmp17_;
	_tmp19_ = wacom_backend_wacom_tool_map_list_tools (_tmp15_, _tmp18_);
	_tmp20_ = _tmp19_;
	_g_object_unref0 (_tmp18_);
	tools = _tmp20_;
	_tmp21_ = tools;
	_tmp22_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp21_);
	_tmp23_ = _tmp22_;
	if (_tmp23_ > 0) {
		WacomStylusView* _tmp24_;
		GeeArrayList* _tmp25_;
		gpointer _tmp26_;
		WacomBackendWacomTool* _tmp27_;
		_tmp24_ = self->priv->stylus_view;
		_tmp25_ = tools;
		_tmp26_ = gee_abstract_list_get ((GeeAbstractList*) _tmp25_, 0);
		_tmp27_ = (WacomBackendWacomTool*) _tmp26_;
		wacom_stylus_view_set_device (_tmp24_, _tmp27_);
		_g_object_unref0 (_tmp27_);
	}
	_g_object_unref0 (tools);
}

static void
wacom_plug_update_current_page (WacomPlug* self)
{
	GtkStack* _tmp15_;
	g_return_if_fail (self != NULL);
	{
		GeeIterator* _device_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
		_tmp0_ = self->priv->devices;
		_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = _tmp2_;
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_device_it = _tmp5_;
		while (TRUE) {
			GeeIterator* _tmp6_;
			WacomBackendDevice* device = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GtkStack* _tmp9_;
			WacomTabletView* _tmp10_;
			GeeHashMap* _tmp11_;
			WacomBackendDevice* _tmp12_;
			gpointer _tmp13_;
			WacomBackendWacomDevice* _tmp14_;
			_tmp6_ = _device_it;
			if (!gee_iterator_next (_tmp6_)) {
				break;
			}
			_tmp7_ = _device_it;
			_tmp8_ = gee_iterator_get (_tmp7_);
			device = (WacomBackendDevice*) _tmp8_;
			_tmp9_ = self->priv->empty_stack;
			gtk_stack_set_visible_child_name (_tmp9_, "main_view");
			_tmp10_ = self->priv->tablet_view;
			_tmp11_ = self->priv->devices;
			_tmp12_ = device;
			_tmp13_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, _tmp12_);
			_tmp14_ = (WacomBackendWacomDevice*) _tmp13_;
			wacom_tablet_view_set_device (_tmp10_, _tmp14_);
			_g_object_unref0 (_tmp14_);
			_g_object_unref0 (device);
			_g_object_unref0 (_device_it);
			return;
		}
		_g_object_unref0 (_device_it);
	}
	_tmp15_ = self->priv->empty_stack;
	gtk_stack_set_visible_child_name (_tmp15_, "no_tablets");
}

static void
wacom_plug_on_device_added (WacomPlug* self,
                            WacomBackendDevice* device)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	wacom_plug_add_known_device (self, device);
	wacom_plug_update_current_page (self);
}

static void
wacom_plug_on_device_removed (WacomPlug* self,
                              WacomBackendDevice* device)
{
	GeeHashMap* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	_tmp0_ = self->priv->devices;
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, device, NULL);
	wacom_plug_update_current_page (self);
}

static void
wacom_plug_real_shown (SwitchboardPlug* base)
{
	WacomPlug * self;
	self = (WacomPlug*) base;
}

static void
wacom_plug_real_hidden (SwitchboardPlug* base)
{
	WacomPlug * self;
	self = (WacomPlug*) base;
}

static void
wacom_plug_real_search_callback (SwitchboardPlug* base,
                                 const gchar* location)
{
	WacomPlug * self;
	self = (WacomPlug*) base;
	g_return_if_fail (location != NULL);
}

static void
wacom_plug_real_search_data_free (gpointer _data)
{
	WacomPlugSearchData* _data_;
	_data_ = _data;
	_g_free0 (_data_->search);
	_g_object_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (WacomPlugSearchData, _data_);
}

static void
wacom_plug_real_search (SwitchboardPlug* base,
                        const gchar* search,
                        GAsyncReadyCallback _callback_,
                        gpointer _user_data_)
{
	WacomPlug * self;
	WacomPlugSearchData* _data_;
	WacomPlug* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (search != NULL);
	self = (WacomPlug*) base;
	_data_ = g_slice_new0 (WacomPlugSearchData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, wacom_plug_real_search_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (search);
	_g_free0 (_data_->search);
	_data_->search = _tmp1_;
	wacom_plug_real_search_co (_data_);
}

static GeeTreeMap*
wacom_plug_search_finish (SwitchboardPlug* base,
                          GAsyncResult* _res_)
{
	GeeTreeMap* result;
	WacomPlugSearchData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static gboolean
wacom_plug_real_search_co (WacomPlugSearchData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = ((GCompareFunc) g_strcmp0);
	_data_->_tmp1_ = g_str_equal;
	_data_->_tmp2_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, (GCompareDataFunc) _data_->_tmp0_, NULL, NULL, (GeeEqualDataFunc) _data_->_tmp1_, NULL, NULL);
	_data_->search_results = _data_->_tmp2_;
	_data_->result = _data_->search_results;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
wacom_plug_class_init (WacomPlugClass * klass,
                       gpointer klass_data)
{
	wacom_plug_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WacomPlug_private_offset);
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug*)) wacom_plug_real_get_widget;
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug*)) wacom_plug_real_shown;
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug*)) wacom_plug_real_hidden;
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug*, const gchar*)) wacom_plug_real_search_callback;
	((SwitchboardPlugClass *) klass)->search = (void (*) (SwitchboardPlug*, const gchar*, GAsyncReadyCallback, gpointer)) wacom_plug_real_search;
	((SwitchboardPlugClass *) klass)->search_finish = (GeeTreeMap* (*) (SwitchboardPlug*, GAsyncResult*)) wacom_plug_search_finish;
	G_OBJECT_CLASS (klass)->finalize = wacom_plug_finalize;
}

static void
wacom_plug_instance_init (WacomPlug * self,
                          gpointer klass)
{
	self->priv = wacom_plug_get_instance_private (self);
	self->priv->devices = NULL;
	self->priv->last_stylus = NULL;
}

static void
wacom_plug_finalize (GObject * obj)
{
	WacomPlug * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WACOM_TYPE_PLUG, WacomPlug);
	_g_object_unref0 (self->priv->main_stack);
	_g_object_unref0 (self->priv->scrolled);
	_g_object_unref0 (self->priv->empty_stack);
	_g_object_unref0 (self->priv->stylus_view);
	_g_object_unref0 (self->priv->tablet_view);
	_g_object_unref0 (self->priv->device_manager);
	_g_object_unref0 (self->priv->devices);
	_g_object_unref0 (self->priv->last_stylus);
	_g_object_unref0 (self->priv->tool_map);
	G_OBJECT_CLASS (wacom_plug_parent_class)->finalize (obj);
}

static GType
wacom_plug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WacomPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wacom_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WacomPlug), 0, (GInstanceInitFunc) wacom_plug_instance_init, NULL };
	GType wacom_plug_type_id;
	wacom_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_PLUG, "WacomPlug", &g_define_type_info, 0);
	WacomPlug_private_offset = g_type_add_instance_private (wacom_plug_type_id, sizeof (WacomPlugPrivate));
	return wacom_plug_type_id;
}

GType
wacom_plug_get_type (void)
{
	static volatile gsize wacom_plug_type_id__once = 0;
	if (g_once_init_enter (&wacom_plug_type_id__once)) {
		GType wacom_plug_type_id;
		wacom_plug_type_id = wacom_plug_get_type_once ();
		g_once_init_leave (&wacom_plug_type_id__once, wacom_plug_type_id);
	}
	return wacom_plug_type_id__once;
}

SwitchboardPlug*
get_plug (GModule* module)
{
	WacomPlug* plug = NULL;
	WacomPlug* _tmp0_;
	SwitchboardPlug* result;
	g_return_val_if_fail (module != NULL, NULL);
	g_debug ("Plug.vala:223: Activating Wacom plug");
	_tmp0_ = wacom_plug_new ();
	plug = _tmp0_;
	result = (SwitchboardPlug*) plug;
	return result;
}

