/* StylusView.c generated by valac 0.56.8, the Vala compiler
 * generated from StylusView.vala, do not modify */

/*
 * Copyright (c) 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "wacom.h"
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <granite.h>

enum  {
	WACOM_STYLUS_VIEW_0_PROPERTY,
	WACOM_STYLUS_VIEW_NUM_PROPERTIES
};
static GParamSpec* wacom_stylus_view_properties[WACOM_STYLUS_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
typedef struct _Block2Data Block2Data;

struct _WacomStylusViewPrivate {
	WacomBackendWacomTool* device;
	GSettings* settings;
	GtkGrid* stylus_grid;
	gint last_grid_y_pos;
};

struct _Block1Data {
	int _ref_count_;
	WacomStylusView* self;
	GtkScale* scale;
	gchar* schema_key;
};

struct _Block2Data {
	int _ref_count_;
	WacomStylusView* self;
	GtkPopover* test_popover;
	WacomWidgetsDrawingArea* test_area;
};

static gint WacomStylusView_private_offset;
static gpointer wacom_stylus_view_parent_class = NULL;

static void wacom_stylus_view_build_button_settings (WacomStylusView* self,
                                              const gchar* label,
                                              const gchar* schema_key);
static void wacom_stylus_view_on_pressure_value_changed (WacomStylusView* self,
                                                  GtkScale* scale,
                                                  const gchar* schema_key);
static void wacom_stylus_view_set_pressure_scale_value_from_settings (WacomStylusView* self,
                                                               GtkScale* scale,
                                                               const gchar* schema_key);
static void wacom_stylus_view_build_pressure_slider (WacomStylusView* self,
                                              const gchar* label,
                                              const gchar* schema_key);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda6_ (Block1Data* _data1_);
static void ___lambda6__gtk_range_value_changed (GtkRange* _sender,
                                          gpointer self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda7_ (WacomStylusView* self,
                 GtkWidget* widget);
static void ___lambda7__gtk_callback (GtkWidget* widget,
                               gpointer self);
static void __lambda8_ (Block2Data* _data2_);
static void ___lambda8__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static GObject * wacom_stylus_view_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void wacom_stylus_view_finalize (GObject * obj);
static GType wacom_stylus_view_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const gint32 WACOM_STYLUS_VIEW_PRESSURE_CURVES[7][4] = {{(gint32) 0, (gint32) 75, (gint32) 25, (gint32) 100}, {(gint32) 0, (gint32) 50, (gint32) 50, (gint32) 100}, {(gint32) 0, (gint32) 25, (gint32) 75, (gint32) 100}, {(gint32) 0, (gint32) 0, (gint32) 100, (gint32) 100}, {(gint32) 25, (gint32) 0, (gint32) 100, (gint32) 75}, {(gint32) 50, (gint32) 0, (gint32) 100, (gint32) 50}, {(gint32) 75, (gint32) 0, (gint32) 100, (gint32) 25}};

static inline gpointer
wacom_stylus_view_get_instance_private (WacomStylusView* self)
{
	return G_STRUCT_MEMBER_P (self, WacomStylusView_private_offset);
}

static void
wacom_stylus_view_build_button_settings (WacomStylusView* self,
                                         const gchar* label,
                                         const gchar* schema_key)
{
	GtkComboBoxText* button_combo = NULL;
	GtkComboBoxText* _tmp0_;
	GSettings* _tmp1_;
	GtkGrid* _tmp2_;
	WacomWidgetsSettingLabel* _tmp3_;
	WacomWidgetsSettingLabel* _tmp4_;
	GtkGrid* _tmp5_;
	gint _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (label != NULL);
	g_return_if_fail (schema_key != NULL);
	_tmp0_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp0_);
	button_combo = _tmp0_;
	gtk_widget_set_hexpand ((GtkWidget*) button_combo, TRUE);
	gtk_combo_box_text_append (button_combo, "default", _ ("Default"));
	gtk_combo_box_text_append (button_combo, "middle", _ ("Middle Mouse Button Click"));
	gtk_combo_box_text_append (button_combo, "right", _ ("Right Mouse Button Click"));
	gtk_combo_box_text_append (button_combo, "back", _ ("Back"));
	gtk_combo_box_text_append (button_combo, "forward", _ ("Forward"));
	_tmp1_ = self->priv->settings;
	g_settings_bind (_tmp1_, schema_key, (GObject*) button_combo, "active-id", G_SETTINGS_BIND_DEFAULT);
	_tmp2_ = self->priv->stylus_grid;
	_tmp3_ = wacom_widgets_setting_label_new (label);
	g_object_ref_sink (_tmp3_);
	_tmp4_ = _tmp3_;
	gtk_grid_attach (_tmp2_, (GtkWidget*) _tmp4_, 0, self->priv->last_grid_y_pos, 1, 1);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = self->priv->stylus_grid;
	gtk_grid_attach (_tmp5_, (GtkWidget*) button_combo, 1, self->priv->last_grid_y_pos, 1, 1);
	_tmp6_ = self->priv->last_grid_y_pos;
	self->priv->last_grid_y_pos = _tmp6_ + 1;
	_g_object_unref0 (button_combo);
}

static void
wacom_stylus_view_on_pressure_value_changed (WacomStylusView* self,
                                             GtkScale* scale,
                                             const gchar* schema_key)
{
	gint new_value = 0;
	gboolean _tmp0_ = FALSE;
	GVariant** values = NULL;
	gint _tmp1_;
	GVariant** _tmp2_;
	gint values_length1;
	gint _values_size_;
	GVariant* array = NULL;
	const GVariantType* _tmp9_;
	GVariant** _tmp10_;
	gint _tmp10__length1;
	GVariant* _tmp11_;
	GSettings* _tmp12_;
	GVariant* _tmp13_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (scale != NULL);
	g_return_if_fail (schema_key != NULL);
	new_value = (gint) gtk_range_get_value ((GtkRange*) scale);
	if (new_value < 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = new_value > 6;
	}
	if (_tmp0_) {
		return;
	}
	_tmp1_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES[0]);
	_tmp2_ = g_new0 (GVariant*, _tmp1_ + 1);
	values = _tmp2_;
	values_length1 = _tmp1_;
	_values_size_ = values_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				GVariant** _tmp5_;
				gint _tmp5__length1;
				GVariant** _tmp6_;
				gint _tmp6__length1;
				gint32 _tmp7_;
				GVariant* _tmp8_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = values;
				_tmp5__length1 = values_length1;
				if (!(i < _tmp5__length1)) {
					break;
				}
				_tmp6_ = values;
				_tmp6__length1 = values_length1;
				_tmp7_ = WACOM_STYLUS_VIEW_PRESSURE_CURVES[new_value][i];
				_tmp8_ = g_variant_new_int32 (_tmp7_);
				g_variant_ref_sink (_tmp8_);
				_g_variant_unref0 (_tmp6_[i]);
				_tmp6_[i] = _tmp8_;
			}
		}
	}
	_tmp9_ = G_VARIANT_TYPE_INT32;
	_tmp10_ = values;
	_tmp10__length1 = values_length1;
	_tmp11_ = g_variant_new_array (_tmp9_, _tmp10_, _tmp10__length1);
	g_variant_ref_sink (_tmp11_);
	_g_variant_unref0 (array);
	array = _tmp11_;
	_tmp12_ = self->priv->settings;
	_tmp13_ = array;
	g_settings_set_value (_tmp12_, schema_key, _tmp13_);
	_g_variant_unref0 (array);
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_variant_unref), NULL);
}

static void
wacom_stylus_view_set_pressure_scale_value_from_settings (WacomStylusView* self,
                                                          GtkScale* scale,
                                                          const gchar* schema_key)
{
	GVariant* settings_value = NULL;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	gint _tmp3_;
	gint* values = NULL;
	gint _tmp5_;
	gint* _tmp6_;
	gint values_length1;
	gint _values_size_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (scale != NULL);
	g_return_if_fail (schema_key != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_value (_tmp0_, schema_key);
	settings_value = _tmp1_;
	_tmp2_ = settings_value;
	_tmp3_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES[0]);
	if (g_variant_n_children (_tmp2_) != ((gsize) _tmp3_)) {
		gint _tmp4_;
		_tmp4_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES[0]);
		g_warning ("StylusView.vala:93: Invalid pressure curve format, expected %d values", _tmp4_);
		_g_variant_unref0 (settings_value);
		return;
	}
	_tmp5_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES[0]);
	_tmp6_ = g_new0 (gint, _tmp5_);
	values = _tmp6_;
	values_length1 = _tmp5_;
	_values_size_ = values_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp7_ = FALSE;
			_tmp7_ = TRUE;
			while (TRUE) {
				gint _tmp9_;
				gint* _tmp10_;
				gint _tmp10__length1;
				GVariant* _tmp11_;
				GVariant* _tmp12_;
				GVariant* _tmp13_;
				if (!_tmp7_) {
					gint _tmp8_;
					_tmp8_ = i;
					i = _tmp8_ + 1;
				}
				_tmp7_ = FALSE;
				_tmp9_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES[0]);
				if (!(i < _tmp9_)) {
					break;
				}
				_tmp10_ = values;
				_tmp10__length1 = values_length1;
				_tmp11_ = settings_value;
				_tmp12_ = g_variant_get_child_value (_tmp11_, (gsize) i);
				_tmp13_ = _tmp12_;
				_tmp10_[i] = (gint) g_variant_get_int32 (_tmp13_);
				_g_variant_unref0 (_tmp13_);
			}
		}
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp14_ = FALSE;
			_tmp14_ = TRUE;
			while (TRUE) {
				gint _tmp16_;
				gboolean match = FALSE;
				if (!_tmp14_) {
					gint _tmp15_;
					_tmp15_ = i;
					i = _tmp15_ + 1;
				}
				_tmp14_ = FALSE;
				_tmp16_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES);
				if (!(i < _tmp16_)) {
					break;
				}
				match = TRUE;
				{
					gint j = 0;
					j = 0;
					{
						gboolean _tmp17_ = FALSE;
						_tmp17_ = TRUE;
						while (TRUE) {
							gint _tmp19_;
							gint* _tmp20_;
							gint _tmp20__length1;
							gint _tmp21_;
							gint32 _tmp22_;
							if (!_tmp17_) {
								gint _tmp18_;
								_tmp18_ = j;
								j = _tmp18_ + 1;
							}
							_tmp17_ = FALSE;
							_tmp19_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES[0]);
							if (!(j < _tmp19_)) {
								break;
							}
							_tmp20_ = values;
							_tmp20__length1 = values_length1;
							_tmp21_ = _tmp20_[j];
							_tmp22_ = WACOM_STYLUS_VIEW_PRESSURE_CURVES[i][j];
							if (_tmp21_ != ((gint) _tmp22_)) {
								match = FALSE;
								break;
							}
						}
					}
				}
				if (match) {
					gtk_range_set_value ((GtkRange*) scale, (gdouble) i);
					break;
				}
			}
		}
	}
	values = (g_free (values), NULL);
	_g_variant_unref0 (settings_value);
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		WacomStylusView* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->scale);
		_g_free0 (_data1_->schema_key);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static void
__lambda6_ (Block1Data* _data1_)
{
	WacomStylusView* self;
	self = _data1_->self;
	wacom_stylus_view_on_pressure_value_changed (self, _data1_->scale, _data1_->schema_key);
}

static void
___lambda6__gtk_range_value_changed (GtkRange* _sender,
                                     gpointer self)
{
	__lambda6_ (self);
}

static void
wacom_stylus_view_build_pressure_slider (WacomStylusView* self,
                                         const gchar* label,
                                         const gchar* schema_key)
{
	Block1Data* _data1_;
	gchar* _tmp0_;
	GtkScale* _tmp1_;
	GtkGrid* _tmp2_;
	WacomWidgetsSettingLabel* _tmp3_;
	WacomWidgetsSettingLabel* _tmp4_;
	GtkGrid* _tmp5_;
	gint _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (label != NULL);
	g_return_if_fail (schema_key != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = g_strdup (schema_key);
	_g_free0 (_data1_->schema_key);
	_data1_->schema_key = _tmp0_;
	_tmp1_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) 0, (gdouble) 6, (gdouble) 1);
	g_object_ref_sink (_tmp1_);
	_data1_->scale = _tmp1_;
	gtk_scale_set_draw_value (_data1_->scale, FALSE);
	gtk_scale_set_has_origin (_data1_->scale, FALSE);
	gtk_range_set_round_digits ((GtkRange*) _data1_->scale, 0);
	gtk_scale_add_mark (_data1_->scale, (gdouble) 0, GTK_POS_BOTTOM, _ ("Soft"));
	gtk_scale_add_mark (_data1_->scale, (gdouble) 6, GTK_POS_BOTTOM, _ ("Firm"));
	wacom_stylus_view_set_pressure_scale_value_from_settings (self, _data1_->scale, _data1_->schema_key);
	g_signal_connect_data ((GtkRange*) _data1_->scale, "value-changed", (GCallback) ___lambda6__gtk_range_value_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp2_ = self->priv->stylus_grid;
	_tmp3_ = wacom_widgets_setting_label_new (label);
	g_object_ref_sink (_tmp3_);
	_tmp4_ = _tmp3_;
	gtk_grid_attach (_tmp2_, (GtkWidget*) _tmp4_, 0, self->priv->last_grid_y_pos, 1, 1);
	_g_object_unref0 (_tmp4_);
	_tmp5_ = self->priv->stylus_grid;
	gtk_grid_attach (_tmp5_, (GtkWidget*) _data1_->scale, 1, self->priv->last_grid_y_pos, 1, 1);
	_tmp6_ = self->priv->last_grid_y_pos;
	self->priv->last_grid_y_pos = _tmp6_ + 1;
	block1_data_unref (_data1_);
	_data1_ = NULL;
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		WacomStylusView* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->test_area);
		_g_object_unref0 (_data2_->test_popover);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static void
__lambda7_ (WacomStylusView* self,
            GtkWidget* widget)
{
	g_return_if_fail (widget != NULL);
	gtk_widget_destroy (widget);
}

static void
___lambda7__gtk_callback (GtkWidget* widget,
                          gpointer self)
{
	__lambda7_ ((WacomStylusView*) self, widget);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda8_ (Block2Data* _data2_)
{
	WacomStylusView* self;
	self = _data2_->self;
	wacom_widgets_drawing_area_clear (_data2_->test_area);
	gtk_widget_show_all ((GtkWidget*) _data2_->test_popover);
}

static void
___lambda8__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
	__lambda8_ (self);
}

void
wacom_stylus_view_set_device (WacomStylusView* self,
                              WacomBackendWacomTool* dev)
{
	Block2Data* _data2_;
	GtkGrid* _tmp0_;
	WacomBackendWacomTool* _tmp1_;
	WacomBackendWacomTool* _tmp2_;
	GSettings* _tmp3_;
	gboolean _tmp4_ = FALSE;
	WacomBackendWacomTool* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	WacomBackendWacomTool* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	WacomBackendWacomTool* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	GtkButton* test_button = NULL;
	GtkButton* _tmp17_;
	GtkPopover* _tmp18_;
	WacomWidgetsDrawingArea* _tmp19_;
	GtkGrid* _tmp20_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (dev != NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = self->priv->stylus_grid;
	gtk_container_foreach ((GtkContainer*) _tmp0_, ___lambda7__gtk_callback, self);
	_tmp1_ = _g_object_ref0 (dev);
	_g_object_unref0 (self->priv->device);
	self->priv->device = _tmp1_;
	_tmp2_ = self->priv->device;
	_tmp3_ = wacom_backend_wacom_tool_get_settings (_tmp2_);
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp3_;
	_tmp5_ = self->priv->device;
	_tmp6_ = wacom_backend_wacom_tool_get_has_pressure_detection (_tmp5_);
	_tmp7_ = _tmp6_;
	if (_tmp7_) {
		WacomBackendWacomTool* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
		_tmp8_ = self->priv->device;
		_tmp9_ = wacom_backend_wacom_tool_get_has_eraser (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp4_ = _tmp10_;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		wacom_stylus_view_build_pressure_slider (self, _ ("Eraser Pressure Feel:"), "eraser-pressure-curve");
	}
	_tmp11_ = self->priv->device;
	_tmp12_ = wacom_backend_wacom_tool_get_num_buttons (_tmp11_);
	_tmp13_ = _tmp12_;
	switch (_tmp13_) {
		case 1:
		{
			wacom_stylus_view_build_button_settings (self, _ ("Button Action:"), "button-action");
			break;
		}
		case 2:
		{
			wacom_stylus_view_build_button_settings (self, _ ("Top Button Action:"), "secondary-button-action");
			wacom_stylus_view_build_button_settings (self, _ ("Bottom Button Action:"), "button-action");
			break;
		}
		case 3:
		{
			wacom_stylus_view_build_button_settings (self, _ ("Top Button Action:"), "secondary-button-action");
			wacom_stylus_view_build_button_settings (self, _ ("Middle Button Action:"), "button-action");
			wacom_stylus_view_build_button_settings (self, _ ("Bottom Button Action:"), "tertiary-button-action");
			break;
		}
		default:
		{
			break;
		}
	}
	_tmp14_ = self->priv->device;
	_tmp15_ = wacom_backend_wacom_tool_get_has_pressure_detection (_tmp14_);
	_tmp16_ = _tmp15_;
	if (_tmp16_) {
		wacom_stylus_view_build_pressure_slider (self, _ ("Tip Pressure Feel:"), "pressure-curve");
	}
	_tmp17_ = (GtkButton*) gtk_button_new_with_label (_ ("Test Tablet Settings"));
	g_object_ref_sink (_tmp17_);
	test_button = _tmp17_;
	_tmp18_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) test_button);
	g_object_ref_sink (_tmp18_);
	_data2_->test_popover = _tmp18_;
	gtk_widget_set_vexpand ((GtkWidget*) _data2_->test_popover, TRUE);
	gtk_widget_set_hexpand ((GtkWidget*) _data2_->test_popover, TRUE);
	gtk_popover_set_position (_data2_->test_popover, GTK_POS_BOTTOM);
	_tmp19_ = wacom_widgets_drawing_area_new ();
	g_object_ref_sink (_tmp19_);
	_data2_->test_area = _tmp19_;
	gtk_widget_set_hexpand ((GtkWidget*) _data2_->test_area, TRUE);
	gtk_widget_set_vexpand ((GtkWidget*) _data2_->test_area, TRUE);
	gtk_container_add ((GtkContainer*) _data2_->test_popover, (GtkWidget*) _data2_->test_area);
	g_signal_connect_data (test_button, "clicked", (GCallback) ___lambda8__gtk_button_clicked, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp20_ = self->priv->stylus_grid;
	gtk_grid_attach (_tmp20_, (GtkWidget*) test_button, 0, self->priv->last_grid_y_pos, 2, 1);
	gtk_widget_show_all ((GtkWidget*) self);
	gtk_stack_set_visible_child_name ((GtkStack*) self, "stylus");
	_g_object_unref0 (test_button);
	block2_data_unref (_data2_);
	_data2_ = NULL;
}

WacomStylusView*
wacom_stylus_view_construct (GType object_type)
{
	WacomStylusView * self = NULL;
	self = (WacomStylusView*) g_object_new (object_type, NULL);
	return self;
}

WacomStylusView*
wacom_stylus_view_new (void)
{
	return wacom_stylus_view_construct (WACOM_TYPE_STYLUS_VIEW);
}

static GObject *
wacom_stylus_view_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WacomStylusView * self;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
	GraniteWidgetsAlertView* no_stylus_view = NULL;
	GraniteWidgetsAlertView* _tmp3_;
	GraniteWidgetsAlertView* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkGrid* _tmp6_;
	GraniteWidgetsAlertView* _tmp7_;
	parent_class = G_OBJECT_CLASS (wacom_stylus_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WACOM_TYPE_STYLUS_VIEW, WacomStylusView);
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->stylus_grid);
	self->priv->stylus_grid = _tmp0_;
	_tmp1_ = self->priv->stylus_grid;
	gtk_grid_set_row_spacing (_tmp1_, 12);
	_tmp2_ = self->priv->stylus_grid;
	gtk_grid_set_column_spacing (_tmp2_, 12);
	_tmp3_ = granite_widgets_alert_view_new (_ ("No Stylus Detected"), _ ("Please move your stylus close to the tablet"), "input-tablet");
	g_object_ref_sink (_tmp3_);
	no_stylus_view = _tmp3_;
	_tmp4_ = no_stylus_view;
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
	gtk_style_context_remove_class (_tmp5_, GTK_STYLE_CLASS_VIEW);
	_tmp6_ = self->priv->stylus_grid;
	gtk_stack_add_named ((GtkStack*) self, (GtkWidget*) _tmp6_, "stylus");
	_tmp7_ = no_stylus_view;
	gtk_stack_add_named ((GtkStack*) self, (GtkWidget*) _tmp7_, "no_stylus");
	gtk_widget_show_all ((GtkWidget*) self);
	gtk_stack_set_visible_child_name ((GtkStack*) self, "no_stylus");
	_g_object_unref0 (no_stylus_view);
	return obj;
}

static void
wacom_stylus_view_class_init (WacomStylusViewClass * klass,
                              gpointer klass_data)
{
	wacom_stylus_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WacomStylusView_private_offset);
	G_OBJECT_CLASS (klass)->constructor = wacom_stylus_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = wacom_stylus_view_finalize;
}

static void
wacom_stylus_view_instance_init (WacomStylusView * self,
                                 gpointer klass)
{
	self->priv = wacom_stylus_view_get_instance_private (self);
	self->priv->last_grid_y_pos = 0;
}

static void
wacom_stylus_view_finalize (GObject * obj)
{
	WacomStylusView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WACOM_TYPE_STYLUS_VIEW, WacomStylusView);
	_g_object_unref0 (self->priv->device);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->stylus_grid);
	G_OBJECT_CLASS (wacom_stylus_view_parent_class)->finalize (obj);
}

static GType
wacom_stylus_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WacomStylusViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wacom_stylus_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WacomStylusView), 0, (GInstanceInitFunc) wacom_stylus_view_instance_init, NULL };
	GType wacom_stylus_view_type_id;
	wacom_stylus_view_type_id = g_type_register_static (gtk_stack_get_type (), "WacomStylusView", &g_define_type_info, 0);
	WacomStylusView_private_offset = g_type_add_instance_private (wacom_stylus_view_type_id, sizeof (WacomStylusViewPrivate));
	return wacom_stylus_view_type_id;
}

GType
wacom_stylus_view_get_type (void)
{
	static volatile gsize wacom_stylus_view_type_id__once = 0;
	if (g_once_init_enter (&wacom_stylus_view_type_id__once)) {
		GType wacom_stylus_view_type_id;
		wacom_stylus_view_type_id = wacom_stylus_view_get_type_once ();
		g_once_init_leave (&wacom_stylus_view_type_id__once, wacom_stylus_view_type_id);
	}
	return wacom_stylus_view_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

