/* TabletView.c generated by valac 0.56.8, the Vala compiler
 * generated from TabletView.vala, do not modify */

/*
 * Copyright (c) 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */

#include "wacom.h"
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>

enum  {
	WACOM_TABLET_VIEW_0_PROPERTY,
	WACOM_TABLET_VIEW_NUM_PROPERTIES
};
static GParamSpec* wacom_tablet_view_properties[WACOM_TABLET_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _WacomTabletViewPrivate {
	WacomBackendWacomDevice* device;
	GSettings* settings;
	GtkComboBoxText* tracking_mode_combo;
	GtkSwitch* left_handed_switch;
};

static gint WacomTabletView_private_offset;
static gpointer wacom_tablet_view_parent_class = NULL;

static GObject * wacom_tablet_view_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void wacom_tablet_view_finalize (GObject * obj);
static GType wacom_tablet_view_get_type_once (void);

static inline gpointer
wacom_tablet_view_get_instance_private (WacomTabletView* self)
{
	return G_STRUCT_MEMBER_P (self, WacomTabletView_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
wacom_tablet_view_set_device (WacomTabletView* self,
                              WacomBackendWacomDevice* dev)
{
	WacomBackendWacomDevice* _tmp0_;
	WacomBackendWacomDevice* _tmp1_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GtkComboBoxText* _tmp4_;
	GSettings* _tmp5_;
	GtkSwitch* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (dev != NULL);
	_tmp0_ = _g_object_ref0 (dev);
	_g_object_unref0 (self->priv->device);
	self->priv->device = _tmp0_;
	_tmp1_ = self->priv->device;
	_tmp2_ = wacom_backend_wacom_device_get_settings (_tmp1_);
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp2_;
	_tmp3_ = self->priv->settings;
	_tmp4_ = self->priv->tracking_mode_combo;
	g_settings_bind (_tmp3_, "mapping", (GObject*) _tmp4_, "active-id", G_SETTINGS_BIND_DEFAULT);
	_tmp5_ = self->priv->settings;
	_tmp6_ = self->priv->left_handed_switch;
	g_settings_bind (_tmp5_, "left-handed", (GObject*) _tmp6_, "active", G_SETTINGS_BIND_DEFAULT);
}

WacomTabletView*
wacom_tablet_view_construct (GType object_type)
{
	WacomTabletView * self = NULL;
	self = (WacomTabletView*) g_object_new (object_type, NULL);
	return self;
}

WacomTabletView*
wacom_tablet_view_new (void)
{
	return wacom_tablet_view_construct (WACOM_TYPE_TABLET_VIEW);
}

static GObject *
wacom_tablet_view_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WacomTabletView * self;
	GtkComboBoxText* _tmp0_;
	GtkComboBoxText* _tmp1_;
	GtkComboBoxText* _tmp2_;
	GtkComboBoxText* _tmp3_;
	GtkSwitch* _tmp4_;
	GtkSwitch* _tmp5_;
	WacomWidgetsSettingLabel* _tmp6_;
	WacomWidgetsSettingLabel* _tmp7_;
	GtkComboBoxText* _tmp8_;
	WacomWidgetsSettingLabel* _tmp9_;
	WacomWidgetsSettingLabel* _tmp10_;
	GtkSwitch* _tmp11_;
	parent_class = G_OBJECT_CLASS (wacom_tablet_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WACOM_TYPE_TABLET_VIEW, WacomTabletView);
	gtk_grid_set_row_spacing ((GtkGrid*) self, 12);
	gtk_grid_set_column_spacing ((GtkGrid*) self, 12);
	_tmp0_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->tracking_mode_combo);
	self->priv->tracking_mode_combo = _tmp0_;
	_tmp1_ = self->priv->tracking_mode_combo;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
	_tmp2_ = self->priv->tracking_mode_combo;
	gtk_combo_box_text_append (_tmp2_, "absolute", _ ("Tablet (absolute)"));
	_tmp3_ = self->priv->tracking_mode_combo;
	gtk_combo_box_text_append (_tmp3_, "relative", _ ("Touchpad (relative)"));
	_tmp4_ = (GtkSwitch*) gtk_switch_new ();
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->left_handed_switch);
	self->priv->left_handed_switch = _tmp4_;
	_tmp5_ = self->priv->left_handed_switch;
	gtk_widget_set_halign ((GtkWidget*) _tmp5_, GTK_ALIGN_START);
	_tmp6_ = wacom_widgets_setting_label_new (_ ("Tracking mode:"));
	g_object_ref_sink (_tmp6_);
	_tmp7_ = _tmp6_;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp7_, 0, 0, 1, 1);
	_g_object_unref0 (_tmp7_);
	_tmp8_ = self->priv->tracking_mode_combo;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp8_, 1, 0, 1, 1);
	_tmp9_ = wacom_widgets_setting_label_new (_ ("Left-handed orientation:"));
	g_object_ref_sink (_tmp9_);
	_tmp10_ = _tmp9_;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp10_, 0, 1, 1, 1);
	_g_object_unref0 (_tmp10_);
	_tmp11_ = self->priv->left_handed_switch;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp11_, 1, 1, 1, 1);
	return obj;
}

static void
wacom_tablet_view_class_init (WacomTabletViewClass * klass,
                              gpointer klass_data)
{
	wacom_tablet_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WacomTabletView_private_offset);
	G_OBJECT_CLASS (klass)->constructor = wacom_tablet_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = wacom_tablet_view_finalize;
}

static void
wacom_tablet_view_instance_init (WacomTabletView * self,
                                 gpointer klass)
{
	self->priv = wacom_tablet_view_get_instance_private (self);
}

static void
wacom_tablet_view_finalize (GObject * obj)
{
	WacomTabletView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WACOM_TYPE_TABLET_VIEW, WacomTabletView);
	_g_object_unref0 (self->priv->device);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->tracking_mode_combo);
	_g_object_unref0 (self->priv->left_handed_switch);
	G_OBJECT_CLASS (wacom_tablet_view_parent_class)->finalize (obj);
}

static GType
wacom_tablet_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WacomTabletViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wacom_tablet_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WacomTabletView), 0, (GInstanceInitFunc) wacom_tablet_view_instance_init, NULL };
	GType wacom_tablet_view_type_id;
	wacom_tablet_view_type_id = g_type_register_static (gtk_grid_get_type (), "WacomTabletView", &g_define_type_info, 0);
	WacomTabletView_private_offset = g_type_add_instance_private (wacom_tablet_view_type_id, sizeof (WacomTabletViewPrivate));
	return wacom_tablet_view_type_id;
}

GType
wacom_tablet_view_get_type (void)
{
	static volatile gsize wacom_tablet_view_type_id__once = 0;
	if (g_once_init_enter (&wacom_tablet_view_type_id__once)) {
		GType wacom_tablet_view_type_id;
		wacom_tablet_view_type_id = wacom_tablet_view_get_type_once ();
		g_once_init_leave (&wacom_tablet_view_type_id__once, wacom_tablet_view_type_id);
	}
	return wacom_tablet_view_type_id__once;
}

